package sun.net.httpserver;

import java.io.IOException;
import java.io.OutputStream;
import java.io.FilterOutputStream;

class UndefLengthOutputStream extends FilterOutputStream
{
    private boolean closed;
    ExchangeImpl t;
    
    UndefLengthOutputStream(ExchangeImpl t, OutputStream out) {
        super(out);
        this.closed = false;
        this.t = t;
    }
    
    @Override
    public void write(int n) throws IOException {
        if (this.closed) {
            throw new IOException("stream closed");
        }
        this.out.write(n);
        return;
    }
    
    @Override
    public void write(byte[] b, int off, int len) throws IOException {
        if (this.closed) {
            throw new IOException("stream closed");
        }
        this.out.write(b, off, len);
        return;
    }
    
    @Override
    public void close() throws IOException {
        if (this.closed) {
            return;
        }
        this.closed = true;
        this.flush();
        LeftOverInputStream originalInputStream = this.t.getOriginalInputStream();
        if (!originalInputStream.isClosed()) {
            try {
                originalInputStream.close();
            }
            catch (IOException ex) {}
        }
        this.t.getHttpContext().getServerImpl().addEvent(new WriteFinishedEvent(this.t));
        return;
    }
}
